# Copyright (C) 2024, UChicago Argonne, LLC
# Licensed under the 3-clause BSD license.  See accompanying LICENSE.txt file
# in the top-level directory.

"""generic implementations of Location to Mask"""
from typing import Optional
from Octeres.SL.abstract_location_to_mask import Abstract_Location_to_Mask


class XLocation_to_Mask_None(Abstract_Location_to_Mask):
    machine_name: Optional[str] = "NONE"
    bit_total = 0

    @classmethod
    def get_parents(cls, machine_name: str, node_name: str) -> list:
        pass

    @classmethod
    def get_obj_type(cls, machine_name: str, node_name: str) -> str:
        pass

    @classmethod
    def generate_tree(cls, level_idx_to_node_names_dct):
        pass


class XLocation_to_Mask_DoesNotExist(Abstract_Location_to_Mask):
    machine_name: Optional[str] = "DOESNOTEXIST"
    bit_total = 0

    @classmethod
    def get_parents(cls, machine_name: str, node_name: str) -> list:
        pass

    @classmethod
    def get_obj_type(cls, machine_name: str, node_name: str) -> str:
        pass

    @classmethod
    def generate_tree(cls, level_idx_to_node_names_dct):
        pass
